package testing.weld.beans;

import javax.validation.Valid;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Pattern;
import javax.validation.constraints.Pattern.Flag;
import javax.ws.rs.Consumes;
import javax.ws.rs.DefaultValue;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.QueryParam;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;
import org.jboss.resteasy.annotations.providers.multipart.MultipartForm;
import testing.weld.forms.RequestForm;

@Path("/dummy")
public interface DummyResource {

    @Consumes(MediaType.MULTIPART_FORM_DATA)
    @Produces("application/json; charset=utf-8")
    @POST
    Response action(
        @NotNull
        @Pattern(regexp="[0-9a-z-]+", flags = Flag.CASE_INSENSITIVE)
        @QueryParam("type")
        String type,

        @NotNull
        @Pattern(regexp="[^\\s]+")
        @QueryParam("name")
        String name,

        @QueryParam("flag")
        @DefaultValue("true")
        boolean flag,

        @Valid
        @NotNull
        @MultipartForm
        RequestForm request
    );

    @Produces("application/json; charset=utf-8")
    @Path("/{id}/status")
    @GET
    Response status(
        @NotNull
        @Pattern(regexp = "[0-9a-z-]++:[0-9a-f]{32}", flags = Flag.CASE_INSENSITIVE)
        @PathParam("id")
        String id
    );

}
