package testing.weld.forms;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import static com.fasterxml.jackson.annotation.JsonInclude.Include.NON_EMPTY;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import com.fasterxml.jackson.databind.node.ObjectNode;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Pattern;

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonInclude(NON_EMPTY)
@JsonPropertyOrder({
    "id",
    "size",
    "md5",
    "otherStuff"
})
public class Metadata {

    @Pattern(regexp = "[0-9a-z-]++:[^\\s]++", flags = Pattern.Flag.CASE_INSENSITIVE)
    @NotNull
    private String id;

    @NotNull
    private Long size;

    @Pattern(regexp = "[0-9a-f]{32}", flags = Pattern.Flag.CASE_INSENSITIVE)
    private String md5;

    private ObjectNode otherStuff;

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public Long getSize() {
        return size;
    }

    public void setSize(Long size) {
        this.size = size;
    }

    public String getMD5() {
        return md5;
    }

    public void setMD5(String md5) {
        this.md5 = md5;
    }

    public ObjectNode getOtherStuff() {
        return otherStuff;
    }

    public void setOtherStuff(ObjectNode otherStuff) {
        this.otherStuff = otherStuff;
    }

    @Override
    public String toString() {
        return new StringBuilder()
            .append("Metadata[")
            .append("id='").append(id)
            .append("',size=").append(size)
            .append(",MD5=").append(md5)
            .append(",otherStuff=").append(otherStuff)
            .append(']')
            .toString();
    }

}
